///////////////////////////////////////////////LED Strip declaration, Variables
#include <Adafruit_NeoPixel.h>

#define LEDNUMBER 6
#define ROW 6
#define COLUMN 7

#define PIN1 11
#define PIN2 10
#define PIN3 9
#define PIN4 8
#define PIN5 7
#define PIN6 6
#define PIN7 5
Adafruit_NeoPixel strip_1 = Adafruit_NeoPixel(LEDNUMBER, PIN1);
Adafruit_NeoPixel strip_2 = Adafruit_NeoPixel(LEDNUMBER, PIN2);
Adafruit_NeoPixel strip_3 = Adafruit_NeoPixel(LEDNUMBER, PIN3);
Adafruit_NeoPixel strip_4 = Adafruit_NeoPixel(LEDNUMBER, PIN4);
Adafruit_NeoPixel strip_5 = Adafruit_NeoPixel(LEDNUMBER, PIN5);
Adafruit_NeoPixel strip_6 = Adafruit_NeoPixel(LEDNUMBER, PIN6);
Adafruit_NeoPixel strip_7 = Adafruit_NeoPixel(LEDNUMBER, PIN7);

const int left = 2, down = 3, right = 4;

const int introPIN = A0;
const int playerOnePIN = A1;
const int playerTwoPIN = A2;
const int winnerPIN = A3;

int ledArray[6][7] = {0};
uint32_t color[] = {0, 0xFF0000, 0xFF7500};

int choosePosition;
bool positionChanged;
int playerID = 1;
int winPos[4][2] = {0};
bool TheEnd = 0;

const int LED = 13;
int ledON = 0, ledOFF = 0;
//////////////////////////////////////////////Void Setup
void setup() {
  Serial.begin(9600);
  int outputs[] = {PIN1, PIN2, PIN3, PIN4, PIN5, PIN6, PIN7, introPIN, playerOnePIN, playerTwoPIN, winnerPIN, LED};
  for (int i = 0; i < 12; i++) {
    pinMode(outputs[i], OUTPUT);
    digitalWrite(outputs[i], LOW);
  }
  int inputs[] = {left, down, right};
  for (int i = 0; i < 3; i++) {
    pinMode(inputs[i], INPUT);
  }
  strip_1.begin(), strip_2.begin(), strip_3.begin(), strip_4.begin(), strip_5.begin(), strip_6.begin(), strip_7.begin();
  ledArray[5][choosePosition] = playerID;
  setColor();

  menu();

}
///////////////////////////////////////////////Void Loop
void loop() {
  if (!TheEnd) {
    chooseColor();
    whosTurn(playerID);
    led();
    if (positionChanged) {
      setColor();
      positionChanged = 0;
      delay(200);
    }
  }
  else led();
}
///////////////////////////////////////////////Functions
void setColor() {
  int LED_NUM = 0;
  strip_1.clear(), strip_2.clear(), strip_3.clear(), strip_4.clear(), strip_5.clear(), strip_6.clear(), strip_7.clear();
  for (int row = 0; row < ROW; row++) {
    if (ledArray[row][0] != 0) {
      strip_1.setPixelColor(LED_NUM, color[ledArray[row][0]]);
    }
    if (ledArray[row][1] != 0) {
      strip_2.setPixelColor(LED_NUM, color[ledArray[row][1]]);
    }
    if (ledArray[row][2] != 0) {
      strip_3.setPixelColor(LED_NUM, color[ledArray[row][2]]);
    }
    if (ledArray[row][3] != 0) {
      strip_4.setPixelColor(LED_NUM, color[ledArray[row][3]]);
    }
    if (ledArray[row][4] != 0) {
      strip_5.setPixelColor(LED_NUM, color[ledArray[row][4]]);
    }
    if (ledArray[row][5] != 0) {
      strip_6.setPixelColor(LED_NUM, color[ledArray[row][5]]);
    }
    if (ledArray[row][6] != 0) {
      strip_7.setPixelColor(LED_NUM, color[ledArray[row][6]]);
    }
    LED_NUM++;
  }
  strip_1.show(), strip_2.show(), strip_3.show(), strip_4.show(), strip_5.show(), strip_6.show(), strip_7.show();
}

void chooseColor() {
  if (digitalRead(down)) {
    for (int nothing = 0; nothing < 5; nothing++) {
      if (!ledArray[nothing][choosePosition]) {
        ledArray[nothing][choosePosition] = playerID;
        ledArray[5][choosePosition] = 0;
        choosePosition = 0;
        setColor();
        if (!whosWinner()) {
          if (playerID == 2) playerID = 1;
          else playerID++;
          delay(500);
          positionChanged = 1;
          break;
        }
        break;
      }
    }
  }
  if (digitalRead(left) && choosePosition > 0) {
    ledArray[5][choosePosition] = 0;
    choosePosition--;
    positionChanged = 1;
  }
  if (digitalRead(right) && choosePosition < 6) {
    ledArray[5][choosePosition] = 0;
    choosePosition++;
    positionChanged = 1;
  }
  ledArray[5][choosePosition] = playerID;
}

int whosWinner() {
  for (int winRow = 0; winRow < 5; winRow++) {
    for (int winColumn = 0; winColumn < 7; winColumn++) {
      if (winRow < 2 && winColumn < 4) {
        if (ledArray[winRow][winColumn] == playerID && ledArray[winRow + 1][winColumn + 1] == playerID && ledArray[winRow + 2][winColumn + 2] == playerID && ledArray[winRow + 3][winColumn + 3] == playerID) {
          winningPositions(winRow, winColumn, winRow + 1, winColumn + 1, winRow + 2, winColumn + 2, winRow + 3, winColumn + 3);
          win(playerID);
          return 1;
          break;
        }
        if (ledArray[winRow + 3][winColumn] == playerID && ledArray[winRow + 2][winColumn + 1] == playerID && ledArray[winRow + 1][winColumn + 2] == playerID && ledArray[winRow][winColumn + 3] == playerID) {
          winningPositions(winRow + 3, winColumn, winRow + 2, winColumn + 1, winRow + 1, winColumn + 2, winRow, winColumn + 3);
          win(playerID);
          return 1;
          break;
        }
      }
      if (winColumn < 4) {
        if (ledArray[winRow][winColumn] == playerID && ledArray[winRow][winColumn + 1] == playerID && ledArray[winRow][winColumn + 2] == playerID && ledArray[winRow][winColumn + 3] == playerID) {
          winningPositions(winRow, winColumn, winRow, winColumn + 1, winRow, winColumn + 2, winRow, winColumn + 3);
          win(playerID);
          return 1;
          break;
        }
      }
      if (winRow < 2) {
        if (ledArray[winRow][winColumn] == playerID && ledArray[winRow + 1][winColumn] == playerID && ledArray[winRow + 2][winColumn] == playerID && ledArray[winRow + 3][winColumn] == playerID) {
          winningPositions(winRow, winColumn, winRow + 1, winColumn, winRow + 2, winColumn, winRow + 3, winColumn);
          win(playerID);
          return 1;
          break;
        }
      }
    }
  }
  return 0;
}

void winningPositions(int oneR, int oneC, int secR, int secC, int thrR, int thrC, int frtR, int frtC) {
  winPos[0][0] = oneR;
  winPos[0][1] = oneC;
  winPos[1][0] = secR;
  winPos[1][1] = secC;
  winPos[2][0] = thrR;
  winPos[2][1] = thrC;
  winPos[3][0] = frtR;
  winPos[3][1] = frtC;
}

void win(int winner) {
  digitalWrite(winnerPIN, HIGH);
  delay(500);

  memset(ledArray, 0, sizeof(ledArray[6][7]) * ROW * COLUMN);
  ledArray[winPos[0][0]][winPos[0][1]] = playerID;
  ledArray[winPos[1][0]][winPos[1][1]] = playerID;
  ledArray[winPos[2][0]][winPos[2][1]] = playerID;
  ledArray[winPos[3][0]][winPos[3][1]] = playerID;
  setColor();
  TheEnd = 1;
}
void whosTurn(int displayPlayer) {
  displayPlayer--;
  if (!displayPlayer) {
    digitalWrite(playerOnePIN, HIGH);
    digitalWrite(playerTwoPIN, LOW);
  }
  if (displayPlayer) {
    digitalWrite(playerOnePIN, LOW);
    digitalWrite(playerTwoPIN, HIGH);
  }
}

void menu() {
  digitalWrite(introPIN, HIGH);
  TheEnd = 0;
  delay(4000);
  digitalWrite(introPIN, LOW);
}

void led() {
  if (ledON != 0) {
    digitalWrite(LED, HIGH);
    ledON--;
  }
  else if (!ledON && ledOFF != 0) {
    digitalWrite(LED, LOW);
    ledOFF--;
  }
  else if (!ledON && !ledOFF) {
    ledON = random(2, 30);
    ledOFF = random(1, 8);
  }
}
